var win = Titanium.UI.currentWindow;
var tableView = {};
var dial = Titanium.UI.createAlertDialog();
var since_id = 1;
var ch = null;
var i = 0;
var c = 0;
var twitterid = 0;
var prev_twitterid = 0;
var db = Titanium.Database.open('filttrdb');
var dbload = true;
var timeline_type = '';

//pull to refresh
var arrow = Titanium.UI.createView({
	backgroundImage:"./images/whiteArrow.png",
	width:23,
	height:60,
	bottom:10,
	left:20
});

var statusLabel = Titanium.UI.createLabel({
	text:"Pull to reload",
	left:55,
	width:200,
	bottom:30,
	height:"auto",
	color:"#576c89",
	textAlign:"center",
	font:{fontSize:13,fontWeight:"bold"},
	shadowColor:"#999",
	shadowOffset:{x:0,y:1}
});

var lastUpdatedLabel = Titanium.UI.createLabel({
	text:"Last Updated: "+formatDate(),
	left:55,
	width:200,
	bottom:15,
	height:"auto",
	color:"#576c89",
	textAlign:"center",
	font:{fontSize:12},
	shadowColor:"#999",
	shadowOffset:{x:0,y:1}
});

var actInd = Titanium.UI.createActivityIndicator({
	left:20,
	bottom:13,
	width:30,
	height:30
});

var tableHeader = Titanium.UI.createView({
	backgroundColor:"#e2e7ed",
	width:320,
	height:60
});
//end

function notYetImplemented()
{
    dial.setTitle('Oops!');
    dial.setMessage('Sorry, that feature has not yet been implemented!');
    dial.show();
}

function processTweets(ret, timeline_type)
{
	var data = [];
	var row = null;
	var photo = null;
	var user = null;
	var comment = null;
	var date = null;
	var filttrdRow = null;
	var fontSize = 16;
	
	// twitter ids are no longer sequential. Hence, we will need to rely on our db's primary key (incremented) to sort them.
	c = ret.length;
	for (i=c-1; i>=0; i--)
	{
	    if (i==0)
	    {
        	since_id = ret[i].id;
        	Titanium.API.log('setting since_id to: '+since_id);
	    }
        
		row = Titanium.UI.createTableViewRow();
		row.selectedBackgroundColor = '#fff';
		row.height = 'auto';
		row.className = 'datarow';
		row.clickName = 'row';

		photo = Titanium.UI.createImageView({
			image:ret[i].user.profile_image_url,
			top:5,
			left:10,
			width:50,
			height:50,
			clickName:'photo'
		});

		row.add(photo);

        user = Titanium.UI.createLabel({
			color:'#576996',
			font:{fontSize:16,fontWeight:'bold', fontFamily:'Arial'},
			left:70,
			top:-1,
			height:30,
			width:200,
			clickName:'user',
			text:ret[i].user.name
		});

		row.filter = ret[i].user.name+' '+ret[i].text;
		row.add(user);

		comment = Titanium.UI.createLabel({
			color:'#222',
			font:{fontSize:fontSize,fontWeight:'normal', fontFamily:'Arial'},
			left:70,
			top:21,
			height:'auto',
			width:200,
			clickName:'comment',
			text:ret[i].text+'\n\n'
		});
		row.add(comment);

		date = Titanium.UI.createLabel({
			color:'#999',
			font:{fontSize:13,fontWeight:'normal', fontFamily:'Arial'},
			left:65,
			bottom:1,
			height:20,
			//width:100,
			clickName:'date',
			text:formatDate(ret[i].created_at)
		});
		row.add(date);
		
		if (ret[i].has_been_filtered == 'yes')
		{
		    filttrdRow = row;
		    row = Titanium.UI.createTableViewRow();
    		row.selectedBackgroundColor = '#fff';
    		row.height = 'auto';
    		row.className = 'filttrdrow';
    		row.clickName = 'row';
    		row.filttrdRow = filttrdRow;
    		
    		if (ret[i].filtered_by == 'flai')
    		{
    		    ret[i].filtered_by = 'Filttr\'d';
    		}
    		else
    		{
    		    ret[i].filtered_by = 'Blacklist\'d';
    		}
    		
    		comment = Titanium.UI.createLabel({
    			color:'#222',
    			font:{fontSize:fontSize,fontWeight:'normal', fontFamily:'Arial'},
    			height:'20',
    			clickName:'comment',
    			text:ret[i].filtered_by+' from '+ret[i].user.name
    		});
    		row.add(comment);
		}
		
		if (dbload == false)
		{
    		//add to database
    		try
    		{
    		    db.execute('INSERT INTO '+timeline_type+' (tid, data, aid) VALUES('+ret[i].id+', \''+escape(JSON.stringify(ret[i]))+'\', '+twitterid+')');
    		}
    		catch (e)
    		{
    		    Titanium.API.log(e);
    		}
        }
        
		if (tableView[twitterid] == undefined) //first load
    	{
    	    data.unshift(row);
	    }
		else //updating
		{
		    if (prev_twitterid != twitterid)
            {
                win.remove(tableView[prev_twitterid]);
                win.add(tableView[twitterid]);
                prev_twitterid = twitterid;
            }
            
    	    tableView[twitterid].insertRowBefore(0, row);
		}
		
	}
	
	if (tableView[twitterid] == undefined) //first load
	{
	    var search = Titanium.UI.createSearchBar({
    		hintText:'Enter text to search'
    	});

    	tableView[twitterid] = Titanium.UI.createTableView({
    		data:data,
    		search:search,
    		searchHidden: true,
    		filterAttribute:'filter',
    		backgroundColor:'white'
    	});
        
        //pull2fresh from appcelerator
        
        tableHeader.add(arrow);
        tableHeader.add(statusLabel);
        tableHeader.add(lastUpdatedLabel);
        tableHeader.add(actInd);
        
        tableView[twitterid].headerPullView = tableHeader;
        
        var pulling = false;
        var reloading = false;
        
    	tableView[twitterid].addEventListener('scroll',function(e)
        {
        	var offset = e.contentOffset.y;
    		var t = Titanium.UI.create2DMatrix();
        	if (offset <= -65.0 && !pulling)
        	{
        		t = t.rotate(-180);
        		pulling = true;
        		arrow.animate({transform:t,duration:180});
        		statusLabel.text = "Release to refresh...";
        	}
        	else if (pulling && offset > -65.0 && offset < 0)
        	{
        		pulling = false;
        		arrow.animate({transform:t,duration:180});
        		statusLabel.text = "Pull down to refresh...";
        	}
    	});
    	
    	tableView[twitterid].addEventListener('scrollEnd',function(e)
        {
        	if (pulling && !reloading && e.contentOffset.y <= -65.0)
        	{
        		reloading = true;
        		pulling = false;
        		arrow.hide();
        		actInd.show();
        		statusLabel.text = "Reloading...";
        		tableView[twitterid].setContentInsets({top:60},{animated:true});
        		arrow.transform=Titanium.UI.create2DMatrix();
        		beginReloading();
        	}
        });
    	
    	tableView[twitterid].addEventListener('click', function(e)
        {
        	// event data
        	var index = e.index;
        	var section = e.section;
        	var row = e.row;
        	var rowdata = e.rowData;
        	if (row.filttrdRow != undefined)
        	{
            	tableView[twitterid].updateRow(index,row.filttrdRow,{animationStyle:Titanium.UI.iPhone.RowAnimationStyle.LEFT});
        	    Titanium.API.log('updating row');
        	}
        	else
        	{
        	    Titanium.API.log('clicked');
        	}
        });
    	
    	if (prev_twitterid != twitterid)
        {
            if (prev_twitterid > 0)
            {
                win.remove(tableView[prev_twitterid]);
            }
            prev_twitterid = twitterid;
        }
	    win.add(tableView[twitterid]);
	}
	
	Titanium.API.log('processed '+timeline_type+' tweets for userid: '+twitterid+' at time: '+Math.round(new Date().getTime() / 1000));
}

function fetchTweets()
{
	if (since_id == 1) //load from db on load
	{
	    Titanium.API.log('trying to fetch from db');
        var rows = db.execute('SELECT data FROM '+timeline_type+' WHERE aid='+twitterid+' ORDER BY id DESC LIMIT 50');
    	var data = [];
        while (rows.isValidRow())
        {
            data.push(JSON.parse(unescape(rows.field(0))));
            rows.next();
        }
        rows.close();
        var l = data.length;
        if (l>0)
        {
    	    Titanium.API.log('fetching from db');
        	processTweets(data, timeline_type);
            since_id = data[0].id;
        	Titanium.API.log('setting since_id to: '+since_id);
        }
        dbload = false;
	}
    
	if (ch != null)
	{
		Titanium.API.log('aborting previous call..');
		ch.abort();
	}
	
	Titanium.API.log('fetching tweets with since_id: '+since_id);
	ch = Titanium.Network.createHTTPClient();

	ch.onload = function()
	{
		Titanium.API.log('Got it.');
        if (parseInt(this.status, 10)==200)
        {
			var ret = JSON.parse(this.responseText);
			if (ret.length>0)
            {
        	    Titanium.API.log('processing tweets from api');
            	processTweets(ret, timeline_type);
            }
            else
            {
                Titanium.API.log('no new tweets');
            }
        }
        else
        {
            dial.setTitle('Oops!');
		    dial.setMessage('Sorry, couldn\'t fetch tweets!');
		    dial.show();
        }
	};
	
	var user = String(Titanium.App.Properties.getString('user'));
	var pass = String(Titanium.App.Properties.getString('pass'));
	
	if (Titanium.Platform.model.indexOf("Simulator") == -1 || 1)
	{
		url = 'https://oauth.filttr.com/statuses/'+timeline_type+'.json?im=yes&count=20&since_id='+since_id;
	}
	else
	{
		url = 'http://localhost/filttrfon/'+timeline_type+'.php?im=yes&count=5&since_id='+since_id;
	}
	
	ch.open('GET',url);
	Titanium.API.log(url);
	
	ch.setRequestHeader('Authorization', 'Basic ' + Titanium.Utils.base64encode(user + ':' + pass));
	
	ch.setTimeout([20000]);
	
	ch.send({});
	Titanium.API.log('waiting for response.');
}

//functions from Appcelerator to mimic pull2refresh
function formatDate()
{
	var date = new Date();
	var datestr = date.getMonth()+'/'+date.getDate()+'/'+date.getFullYear();
	if (date.getHours()>=12)
	{
		datestr+=' '+(date.getHours()==12 ? date.getHours() : date.getHours()-12)+':'+date.getMinutes()+' PM';
	}
	else
	{
		datestr+=' '+date.getHours()+':'+date.getMinutes()+' AM';
	}
	return datestr;
}

function endReloading()
{
	tableView[twitterid].setContentInsets({top:0},{animated:true});
	reloading = false;
	lastUpdatedLabel.text = "Last Updated: "+formatDate();
	statusLabel.text = "Pull down to refresh...";
	actInd.hide();
	arrow.show();
}

function beginReloading()
{
	fetchTweets(timeline_type);
	setTimeout(endReloading,2000);
}